AIGameSettingControls.TowerLapseTime = class extends AIGameSettingControlInt
{
	constructor(...args)
	{
		super(...args);
		this.defaultValue = 360;
		g_GameSettings.playerAI.watch(() => this.render(), ["values"]);
	}

	onOpenPage(playerIndex, enabled)
	{
		super.onOpenPage(playerIndex, enabled);
		this.render();
	}

	render()
	{
		const ai = g_GameSettings.playerAI.get(this.playerIndex);
		this.setHidden(!ai);
		if (ai)
		{
			const value = ai.military?.towerLapseTime ?? this.defaultValue;
			this.setIntValue(value);
		}
	}

	onValueChange(value)
	{
		const ai = g_GameSettings.playerAI.get(this.playerIndex);
		const military = ai && ai.military ? { ...ai.military, "towerLapseTime": value } : { "towerLapseTime": value };
		g_GameSettings.playerAI.setMilitary(this.playerIndex, military);
		this.gameSettingsController.setNetworkInitAttributes();
	}
};

AIGameSettingControls.TowerLapseTime.prototype.TitleCaption =
	translate("Tower Lapse Time");
